"""
Installer Tool

"""

from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFBoringTool import BoringTool, tool_globals 
from cStringIO import StringIO

def install(self):
    " Register the PayPalIPNTool with portal_types and friends "
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')
    urltool = getToolByName(self, 'portal_url')
    actionstool = getToolByName(self, 'portal_actions')
 
    # Add the PayPalIPNTool tool to the site's root
    p = urltool.getPortalObject()
    tool_id = BoringTool.BoringTool.id
    if not tool_id in p.objectIds():
        p.manage_addProduct['cmfpaypalipn'].manage_addTool(
            type=BoringTool.BoringTool.meta_type)
        out.write("Added %s tool\n" % tool_id)
    else:
        out.write("Already have %s tool, skipping\n" % tool_id)
    
    # Register Filesystem Directory View for our skins.
    skinfol_name = 'cmfpaypalipn'
    if skinfol_name not in skinstool.objectIds():
        # add Filesystem Directory Views for any sub-directories
        # in our skins/ directory.  These directories should already be
        # configured.  skins/ itself is NOT used for an FSDV.
        addDirectoryViews(skinstool, 'skins', tool_globals)
        out.write("Added %s directory view to portal_skins\n" % skinfol_name)

    # add our new FSDV to all skinpaths, unless it already exists.
    # I'll just put it at the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = [s.strip() for s in path.split(',')]
        if skinfol_name not in path:
            path.append(skinfol_name)
            path = ', '.join(path)
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Added %s to %s skin\n" % (skinfol_name, skin))
        else:
            out.write("Skipping %s skin, %s is already set up\n" % (skin,
                skinfol_name))

    # Register as an Action Provider
    tool_id = BoringTool.BoringTool.id
    if tool_id in actionstool.listActionProviders():
        out.write("%s is already registered as an action provider.\n" %
                  tool_id)
    else:
        actionstool.addActionProvider(tool_id) 
        out.write("Registered %s as a new action provider.\n" % tool_id)
       
    
    return out.getvalue()

